package cn.com.ctop.crawler.modules.appium.service.impl;

import cn.com.ctop.common.module.utils.ResultMapUtils;
import cn.com.ctop.common.module.utils.StatusCode;
import cn.com.ctop.crawler.modules.appium.entity.AppiumJob;
import cn.com.ctop.crawler.modules.appium.entity.AppiumTask;
import cn.com.ctop.crawler.modules.appium.entity.AppiumTaskItem;
import cn.com.ctop.crawler.modules.appium.mapper.AppiumJobMapper;
import cn.com.ctop.crawler.modules.appium.mapper.AppiumTaskItemMapper;
import cn.com.ctop.crawler.modules.appium.service.IAppiumJobService;
import cn.com.ctop.crawler.modules.core.util.AppiumUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import io.appium.java_client.android.AndroidDriver;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 爬虫调度任务
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-11-14
 */
@Slf4j
@Service
public class AppiumJobServiceImpl extends ServiceImpl<AppiumJobMapper, AppiumJob> implements IAppiumJobService {
    @Autowired
    private AppiumJobMapper appiumJobMapper;
    @Autowired
    private AppiumTaskItemMapper taskItemMapper;

    @Override
    public void runTask(Long jobId, Long num) {
        //TODO 需要考虑多个任务并列
        //1:根据jobId查询所属执行task信息
        List<AppiumTask> taskList = appiumJobMapper.getTaskByJobId(jobId);
    }

    @Override
    public String loginTask(Long taskId) {
        String kuaishouId = null;
        try {
            AppiumUtil appiumUtil = new AppiumUtil();
            AndroidDriver androidDriver = appiumUtil.initAndroidDriver("http://39.106.184.70:4723/wd/hub", "183.131.157.66:10005", "com.smile.gifmaker", "com.yxcorp.gifshow.HomeActivity");
//            appiumUtil.loginTask(androidDriver, null, null);
            Map<String, Object> result = new HashMap<>();
            ResultMapUtils.setResultMap(result, StatusCode.KUAISHOU_CRAWLER_APP_SUCCESS.getCode());
            boolean loop = true;
            while (loop) {
                Integer code = (Integer) result.get("code");
                if (null != code && code != StatusCode.KUAISHOU_CRAWLER_APP_SUCCESS.getCode()) {
                    kuaishouId = (String) result.get("kuaishouId");
                    androidDriver.quit();
                    break;
                }
                Thread.sleep(3000L);
                String packageName = androidDriver.getCurrentPackage();
                String activityName = androidDriver.currentActivity();
                System.out.println(packageName + ":" + activityName);
                List<AppiumTaskItem> taskItems = taskItemMapper.selectByParams(packageName, activityName, taskId);
                if (null != taskItems || taskItems.size() > 0) {
                    for (AppiumTaskItem item : taskItems) {
                        result = appiumUtil.runLoginTask(androidDriver, item, result);
                    }
                }
                result = appiumUtil.checkMethod(androidDriver, activityName, result);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println(kuaishouId);
        return kuaishouId;
    }
}
